| dbxcompress

## Wiki

The master copies of EMBOSS documentation are available at http://emboss.open-bio.org/wiki/Appdocs on the EMBOSS Wiki.

Please help by correcting and extending the Wiki pages.

## Function

Compress an uncompressed dbx index

## Description

dbxcompress compressed EMBOSS B+tree format index files. By default, the indexing applications in EMBOSS compress all index files.

Indexes modified by dbxuncompress and indexes prior to EMBOSS 6.4.0 are uncompressed.

## Algorithm

The B+tree index files contain discrete pages with a known maximum size, filled from the first byte with a count of index terms.

dbxcompress reads all pages, calculating the free space at the end of each page, and then rewrite the pages to disk removing all free space.

The final page is always written in full. This allows index reading to assume the maximum page size in all cases without reading beyond the end of file.

Uncompressed index files are required for updating an existing index. Compressed index files provide more efficient storage and retrieval.

## Usage

Here is a sample session with dbxcompress

    % dbxcompress embl -indexdir . -field des
    Compress an uncompressed dbx index
    Output file [embl.dbxcompress]:

Go to the output files for this example

## Command line arguments

    Compress an uncompressed dbx index
    Version: EMBOSS:6.6.0.0

       Standard (Mandatory) qualifiers:
      [-dbname]            string     EMBOSS database name (Any string from 2 to
                                      19 characters, matching regular expression
                                      /[A-z][A-z0-9_]+/)
      [-field]             string     EMBOSS database field (Any string)
       -outfile            outfile    [*.dbxcompress] Output file name

       Additional (Optional) qualifiers: (none)
       Advanced (Unprompted) qualifiers:
       -indexdir           directory  Index directory (optional)

       Associated qualifiers:

       "-indexdir" associated qualifiers
       -extension          string     Default file extension

       "-outfile" associated qualifiers
       -odirectory         string     Output directory

       General qualifiers:
       -auto               boolean    Turn off prompts
       -stdout             boolean    Write first file to standard output
       -filter             boolean    Read first file from standard input, write
                                      first file to standard output
       -options            boolean    Prompt for standard and additional values
       -debug              boolean    Write debug output to program.dbg
       -verbose            boolean    Report some/full command line options
       -help               boolean    Report command line options and exit. More
                                      information on associated and general
                                      qualifiers can be found with -help -verbose
       -warning            boolean    Report warnings
       -error              boolean    Report errors
       -fatal              boolean    Report fatal errors
       -die                boolean    Report dying program messages
       -version            boolean    Report version number and exit

Qualifier | Type | Description | Allowed values | Default
--- | --- | --- | --- | ---
Standard (Mandatory) qualifiers
[-dbname] (Parameter 1) | string | EMBOSS database name | Any string from 2 to 19 characters, matching regular expression /[A-z][A-z0-9_]+/ | Required
[-field] (Parameter 2) | string | EMBOSS database field | Any string |
-outfile | outfile | Output file name | Output file | <*>.dbxcompress
Additional (Optional) qualifiers
(none)
Advanced (Unprompted) qualifiers
-indexdir | directory | Index directory (optional) | Directory |
Associated qualifiers
"-indexdir" associated directory qualifiers
-extension | string | Default file extension | Any string |
"-outfile" associated outfile qualifiers
-odirectory | string | Output directory | Any string |
General qualifiers
-auto | boolean | Turn off prompts | Boolean value Yes/No | N
-stdout | boolean | Write first file to standard output | Boolean value Yes/No | N
-filter | boolean | Read first file from standard input, write first file to standard output | Boolean value Yes/No | N
-options | boolean | Prompt for standard and additional values | Boolean value Yes/No | N
-debug | boolean | Write debug output to program.dbg | Boolean value Yes/No | N
-verbose | boolean | Report some/full command line options | Boolean value Yes/No | Y
-help | boolean | Report command line options and exit. More information on associated and general qualifiers can be found with -help -verbose | Boolean value Yes/No | N
-warning | boolean | Report warnings | Boolean value Yes/No | Y
-error | boolean | Report errors | Boolean value Yes/No | Y
-fatal | boolean | Report fatal errors | Boolean value Yes/No | Y
-die | boolean | Report dying program messages | Boolean value Yes/No | Y
-version | boolean | Report version number and exit | Boolean value Yes/No | N

## Input file format

dbxcompress reads the index files for a database created with an older version of one of the 'dbx' indexing programs, or uncompressed with dbxuncompress.

## Output file format

dbxcompress rewrites the index files in compressed form.

### Output files for usage example

### File: embl.pxde

    Type         Secondary
    Compress     Yes
    Pages        21
    Secpages     225
    Order        22
    Fill         21
    Level        0
    Pagesize     2048
    Cachesize    20000
    Order2       16
    Fill2        24
    Secpagesize  512
    Seccachesize 20000
    Count        223
    Fullcount    445
    Kwlimit      75
    Idlimit      15

### File: embl.xde

This file contains non-printing characters and so cannot be displayed here.

### File: embl.dbxcompress

    Compressing index 'des' for database 'embl'
    Index 'des' opened, compressing
    Completed

## Data files

None.

## Notes

None.

## References

None.

## Warnings

None.

## Diagnostic Error Messages

None.

## Exit status

It always exits with status 0.

## Known bugs

None.

## See also

Program name | Description
--- | ---
dbiblast | Index a BLAST database
dbifasta | Index a fasta file database
dbiflat | Index a flat file database
dbigcg | Index a GCG formatted database
dbxedam | Index the EDAM ontology using b+tree indices
dbxfasta | Index a fasta file database using b+tree indices
dbxflat | Index a flat file database using b+tree indices
dbxgcg | Index a GCG formatted database using b+tree indices
dbxobo | Index an obo ontology using b+tree indices
dbxreport | Validate index and report internals for dbx databases
dbxresource | Index a data resource catalogue using b+tree indices
dbxstat | Dump statistics for dbx databases
dbxtax | Index NCBI taxonomy using b+tree indices
dbxuncompress | Uncompress a compressed dbx index

## Author(s)

Peter Rice
European Bioinformatics Institute, Wellcome Trust Genome Campus, Hinxton, Cambridge CB10 1SD, UK

Please report all bugs to the EMBOSS bug team (emboss-bug © emboss.open-bio.org) not to the original author.

## History

## Target users

This program is intended to be used by administrators responsible for software and database installation and maintenance.

## Comments

None